/*
 * Test.cs --
 *
 * Copyright (c) 2007-2012 by Joe Mistachkin.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * RCS: @(#) $Id: $
 */

#if STATIC
using System.IO;
using Eagle._Attributes;
using Eagle._Components.Public;
using Eagle._Constants;

namespace Eagle._Shell
{
    [ObjectId("dc66a9e6-ee2d-4d7a-a1bb-b52eb1b9bd75")]
    internal sealed class Test
    {
        private static void TestStream(
            Interpreter interpreter
            )
        {
            byte[] buffer = {
            //  <sp>  s     e     t     <sp>     x  <sp>     1  <cr>  <lf>  <nul>
                0x20, 0x73, 0x65, 0x74, 0x20, 0x78, 0x20, 0x31, 0x0D, 0x0A, 0x00
            };

            using (StreamReader reader = new StreamReader(new MemoryStream(buffer)))
            {
                reader.DiscardBufferedData();
                reader.BaseStream.Seek(0, SeekOrigin.Begin);

                ReturnCode code;
                Result result = null;
                int errorLine = 0;

                code = Engine.EvaluateStream(
                    interpreter, null, reader, 0, Length.Invalid, EngineFlags.None,
                    SubstitutionFlags.All, EventFlags.Engine, ExpressionFlags.All,
                    ref result, ref errorLine);

                interpreter.Host.WriteResultLine(code, result, errorLine);

                reader.DiscardBufferedData();
                reader.BaseStream.Seek(0, SeekOrigin.Begin);

                result = null;
                errorLine = 0;

                code = Engine.EvaluateStream(
                    interpreter, null, reader, 0, 4, EngineFlags.None,
                    SubstitutionFlags.All, EventFlags.Engine, ExpressionFlags.All,
                    ref result, ref errorLine);

                interpreter.Host.WriteResultLine(code, result, errorLine);

                reader.DiscardBufferedData();
                reader.BaseStream.Seek(0, SeekOrigin.Begin);

                result = null;
                errorLine = 0;

                code = Engine.EvaluateStream(
                    interpreter, null, reader, 1, 3, EngineFlags.None,
                    SubstitutionFlags.All, EventFlags.Engine, ExpressionFlags.All,
                    ref result, ref errorLine);

                interpreter.Host.WriteResultLine(code, result, errorLine);

                reader.DiscardBufferedData();
                reader.BaseStream.Seek(0, SeekOrigin.Begin);

                result = null;
                errorLine = 0;

                code = Engine.EvaluateStream(
                    interpreter, null, reader, 1, 2, EngineFlags.None,
                    SubstitutionFlags.All, EventFlags.Engine, ExpressionFlags.All,
                    ref result, ref errorLine);

                interpreter.Host.WriteResultLine(code, result, errorLine);
            }
        }
    }
}
#endif
